# -*- coding:Utf-8 -*-
# ./addons/eventscripts/signconnect/signconnect.py

'''
-- SignConnect
-- v1.22
-- By Messiah93
-- http://messiah93.com
'''

import es
import usermsg
import playerlib
import time
import threading

import psyco
psyco.full()

info = es.AddonInfo()
info.name = "[FR] SignConnect"
info.version = "v1.22"
info.author = "Messiah93" 
info.url = "http://addons.eventscripts.com/addons/view/SignConnect"

# cPython:
ENABLED = es.ServerVar("signconnect_enable", 1)
ENABLED_LOGS = es.ServerVar("signconnect_log", 1)
LOG_SUFFIX = es.ServerVar("signconnect_logsuffix", "CSS_SERVER")
MSG_CONNECTING = es.ServerVar("signconnect_msg_connecting", 1)
MSG_BANNED = es.ServerVar("signconnect_msg_banned", 1)
MSG_KICKED = es.ServerVar("signconnect_msg_kicked", 1)

UserList = {}

def load ():
    global UserList
    es.mexec("../addons/eventscripts/signconnect/signconnect_config.cfg")
    for boucle_userid in es.getUseridList():
        if es.getplayersteamid(boucle_userid) != "BOT":
            UserList[boucle_userid] = playerlib.getPlayer(boucle_userid).get("address")
    es.ServerVar("Messiah93_SignConnect", info["version"]).makepublic()
    es.msg("[SignConnect] Chargé.")
    es.dbgmsg(0, "[ES::SignConnect] Charge.")

def unload ():
    es.msg("[SignConnect] Stoppé.")
    es.dbgmsg(0, "[ES::SignConnect] Stoppe.")

def player_activate (event_var):
    global UserList
    if int(ENABLED):
        if event_var["userid"] not in UserList:
            UserList[event_var["userid"]] = playerlib.getPlayer(event_var["userid"]).get("address")
            goMessage("Connecté", event_var["es_username"], event_var["es_steamid"], playerlib.getPlayer(event_var["userid"]).get("address"))

def player_connect (event_var):
    if int(ENABLED):
        if int(MSG_CONNECTING):
            goMessage("Connexion", event_var["name"], event_var["networkid"], event_var["address"])

def player_disconnect (event_var):
    global UserList
    if int(ENABLED):
        if event_var["es_steamid"] and event_var["es_username"]:
            if event_var["userid"] in UserList:
                if event_var["reason"] == "Kicked by Console":
                    goMessage("Kické", event_var["es_username"], event_var["es_steamid"], UserList[event_var["userid"]])
                elif event_var["reason"] == "Client timed out":
                    goMessage("Timed out", event_var["es_username"], event_var["es_steamid"], UserList[event_var["userid"]])
                elif event_var["reason"] == "Disconnect by user.":
                    goMessage("Déconnecté", event_var["es_username"], event_var["es_steamid"], UserList[event_var["userid"]])
                del UserList[event_var["userid"]]

def server_addban (event_var):
    if int(ENABLED):
        if event_var["userid"] in UserList:
            if int(event_var["kicked"]):
                goMessage("Kické et banni", event_var["name"], event_var["networkid"], UserList[event_var["userid"]])
            else:
                goMessage("Banni", event_var["name"], event_var["networkid"], UserList[event_var["userid"]])
	
def goMessage (mode, name, steamID, ip):
    if steamID != "BOT":
        usermsg.saytext2("#all", -1, "%s: %s <%s>" % (mode, name, steamID))
        if int(ENABLED_LOGS) == 1:
            es.dbgmsg(0, "[ES::SignConnect] [%s] : %s - %s <%s> [%s]" % (LOG_SUFFIX, mode, name, steamID, ip))
        elif int(ENABLED_LOGS) == 2:
            threading.Thread(None, writeInLogFile, "signconnect_writelogs", (mode, name, steamID, ip)).start()

def writeInLogFile (mode, name, steamID, ip):
    try:
        fichier = open(es.server_var["eventscripts_gamedir"] + "/addons/eventscripts/signconnect/signconnect_logs.txt", "a+")
        fichier.write("[ES::SignConnect] [%s] (%s) : %s - %s <%s> [%s]\n" % (str(LOG_SUFFIX), time.strftime('%d/%m/%y %H:%M',time.localtime()), mode, name, steamID, ip))
    except:
        gamethread.queue(es.dbgmsg, (0, "[ES::SignConnect] LOGERROR : Le fichier signconnect_logs.txt est innacessible."))
    finally:
        fichier.close()